//Experiment Number:10 
//Write a program to perform Frequency Shift Keying Generation and Detection
//Analog and Digital Communication Laboratory 
//B.Tech II Year II Sem
//Student Name:               Enrolment Number:  
// Course Instructor: Aqeel Shaik
// Sreyas Institute Of Engineering & Technology, Hyderabad.
//-------------------------------------------------------------------------------//


// OS : Windows 10.1
// Scilab 6.0.2

clc
clear
close

n=[1 0 1 0 0 1];   // Random binary Input

// Binary to polar conversion of Bits

for m=1:length(n)
     if n(m)==0
         nn(m)=-1;
     else
         nn(m)=1;
     end
end


// Generating NRZ Waveform from bit sequence of  bit duration 1 sec

i=1;
t=0:0.01:length(n);

for j=1:length(t)
    if t(j)<=i
        data(j)=nn(i);
    else
      
        i=i+1;
        data(j)=nn(i);
  
    end
   
end

 //Plotting of NRZ Data 

figure(1)
subplot(3,1,1);
plot(t,data');
h=gca();
h.data_bounds=[0,-1.5;length(n),1.5]
xlabel('TIME');
ylabel('AMPLITUDE')
title('BINARY INPUT');

//Carrier Generation
carrier_1=sin(2.*%pi*8*t); // Higher Frequency Carrier
subplot(3,1,2);
plot(t,carrier_1);
xlabel('TIME');
ylabel('AMPLITUDE')
title('CARRIER SIGNAL 1');

carrier_2=sin(2.*%pi*3*t);  // Lower Frequency Carrier
subplot(3,1,3);
plot(t,carrier_2);
xlabel('TIME');
ylabel('AMPLITUDE')
title('CARRIER SIGNAL 2');

  //FSK SIGNAL GENERATION
for j=1:length(t)
    if data(j)==1
        fsk(j)=carrier_1(j);
    else
        fsk(j)=carrier_2(j);
    end
    
end

figure(2)
subplot(3,1,1);
plot(t,fsk');
xlabel('TIME');
ylabel('AMPLITUDE')
title('FREQUENCY SHIFT KEYING SIGNAL');


//Demodualation of FSK Signal
for j=1:length(t)
    if fsk(j)==carrier_1(j)
        demod(j)=1
    else
        demod(j)=-1
    end
    
end

figure(2)
subplot(3,1,2)
plot(t,demod')
xlabel('TIME');
ylabel('AMPLITUDE')
title('RECOVERED BINARY DATA');
h=gca();
h.data_bounds=[0,-1.5;length(n),1.5]
