//Experiment Number:8 
//Write a program to perform Binary Amplitude Shift Keying Generation and Detection
//Analog and Digital Communication Laboratory 
//B.Tech II Year II Sem
//Student Name:               Enrolment Number:  
// Course Instructor: Aqeel Shaik
// Sreyas Institute Of Engineering & Technology, Hyderabad.
//-------------------------------------------------------------------------------//


// OS : Windows 10.1
// Scilab 6.0.2

clc
clear
close

n=[0 1 0 1 0 0];   // Random binary Input

// Binary to polar conversion of Bits

for m=1:length(n)
     if n(m)==0
         nn(m)=-1;
     else
         nn(m)=1;
     end
end


// Generating NRZ Waveform from bit sequence of  bit duration 1 sec

i=1;
t=0:0.01:length(n);

for j=1:length(t)
    if t(j)<=i
        data(j)=nn(i);
    else
      
        i=i+1;
        data(j)=nn(i);
  
    end
   
end

figure(1)
subplot(3,1,1);
plot(t,data');
h=gca();
h.data_bounds=[0,-1.5;length(n),1.5]
xlabel('TIME');
ylabel('AMPLITUDE')
title('BINARY INPUT');

//Carrier Generation
carrier=sin(2.*%pi*4*t); 
subplot(3,1,2);
plot(t,carrier);
xlabel('TIME');
ylabel('AMPLITUDE')
title('CARRIER SIGNAL ');


  //AMPLITUDE SHIFT KEYING SIGNAL GENERATION
for j=1:length(t)
    if data(j)==1
        ask(j)=carrier(j);
    else
        ask(j)=0;
    end
    
end


subplot(3,1,3);
plot(t,ask');
xlabel('TIME');
ylabel('AMPLITUDE')
title('AMPLITUDE SHIFT KEYING SIGNAL');


//Demodualation of ASK Signal
for j=1:length(t)
    if ask(j)==carrier(j)
        demod(j)=1
    else
        demod(j)=-1
    end
    
end

figure(2)
subplot(3,1,1)
plot(t,demod')
xlabel('TIME');
ylabel('AMPLITUDE')
title('DEMODULATED MESSAGE SIGNAL');
h=gca();
h.data_bounds=[0,-1.5;length(n),1.5]
