//Experiment Number:9
//Write a program to perform Binary Phase Shift Keying Generation and Detection
//Analog and Digital Communication Laboratory 
//B.Tech II Year II Sem
//Student Name:               Enrolment Number:  
// Course Instructor: Aqeel Shaik
// Sreyas Institute Of Engineering & Technology, Hyderabad.
//-------------------------------------------------------------------------------//


// OS : Windows 10.1
// Scilab 6.0.2

clear
clc
close

n=[1 0 1 0 1 1];//INPUT RANDOM BINARY SEQUENCE

// BINARY TO POLAR CONVERSION
for m=1:length(n)
     if n(m)==0
         nn(m)=-1;
     else
         nn(m)=1;
     end
end

 // Generating NRZ Waveform from bit sequence of  bit duration 1 sec
 
i=1;
t=0:0.01:length(n);

for j=1:length(t)
    if t(j)<=i
        data(j)=nn(i);
    else
      
        i=i+1;
        data(j)=nn(i);
  
    end 
end

// Plotting of NRZ Data Waveform
figure(1)
subplot(3,1,1);
plot(t,data');
h=gca();
h.data_bounds=[0,-1.5;length(n),1.5]
xlabel('TIME');
ylabel('AMPLITUDE')
title('BINARY INPUT');

 //Carrier Generation
 
carrier=sin(2.*%pi*2*t); 
subplot(3,1,2);
plot(t,carrier);
xlabel('TIME');
ylabel('AMPLITUDE')
title('CARRIER SIGNAL');


//Generation of BPSK Signal
z=carrier';
bpsk=data.*z;
subplot(3,1,3);
plot(t,bpsk');
xlabel('TIME');
ylabel('AMPLITUDE')
title('BINARY PHASE SHIFT KEYING SIGNAL');


//Demodulation of BPSK Signal
for j=1:length(t)
    if carrier(j)==bpsk(j)
        demod(j)=1;
    else
        demod(j)=-1;
    end
    
end

figure(2)
subplot(3,1,1);
plot(t,demod');
xlabel('TIME');
ylabel('AMPLITUDE')
title('RECOVERED BINARY DATA');
h=gca();
h.data_bounds=[0,-1.5;6,1.5]

